*** a/contrib/postgres_fdw/postgres_fdw.c
--- b/contrib/postgres_fdw/postgres_fdw.c
***************
*** 2919,2924 **** postgresImportForeignSchema(ImportForeignSchemaStmt *stmt, Oid serverOid)
--- 2978,3308 ----
  }
  
  /*
+  * Construct PgFdwRelationInfo from two join sources
+  */
+ static void
+ merge_fpinfo(RelOptInfo *outerrel,
+ 			 RelOptInfo *innerrel,
+ 			 PgFdwRelationInfo *fpinfo,
+ 			 JoinType jointype,
+ 			 double rows,
+ 			 int width)
+ {
+ 	PgFdwRelationInfo *fpinfo_o;
+ 	PgFdwRelationInfo *fpinfo_i;
+ 
+ 	fpinfo_o = (PgFdwRelationInfo *) outerrel->fdw_private;
+ 	fpinfo_i = (PgFdwRelationInfo *) innerrel->fdw_private;
+ 
+ 	/* Mark that this join can be pushed down safely */
+ 	fpinfo->pushdown_safe = true;
+ 
+ 	/* Join relation must have conditions come from sources */
+ 	fpinfo->remote_conds = list_concat(copyObject(fpinfo_o->remote_conds),
+ 									   copyObject(fpinfo_i->remote_conds));
+ 	fpinfo->local_conds = list_concat(copyObject(fpinfo_o->local_conds),
+ 									  copyObject(fpinfo_i->local_conds));
+ 
+ 	/* Only for simple foreign table scan */
+ 	fpinfo->attrs_used = NULL;
+ 
+ 	/* rows and width will be set later */
+ 	fpinfo->rows = rows;
+ 	fpinfo->width = width;
+ 
+ 	/* A join have local conditions for outer and inner, so sum up them. */
+ 	fpinfo->local_conds_cost.startup = fpinfo_o->local_conds_cost.startup +
+ 									   fpinfo_i->local_conds_cost.startup;
+ 	fpinfo->local_conds_cost.per_tuple = fpinfo_o->local_conds_cost.per_tuple +
+ 										 fpinfo_i->local_conds_cost.per_tuple;
+ 
+ 	/* Don't consider correlation between local filters. */
+ 	fpinfo->local_conds_sel = fpinfo_o->local_conds_sel *
+ 							  fpinfo_i->local_conds_sel;
+ 
+ 	fpinfo->use_remote_estimate = false;
+ 
+ 	/*
+ 	 * These two comes default or per-server setting, so outer and inner must
+ 	 * have same value.
+ 	 */
+ 	fpinfo->fdw_startup_cost = fpinfo_o->fdw_startup_cost;
+ 	fpinfo->fdw_tuple_cost = fpinfo_o->fdw_tuple_cost;
+ 
+ 	/*
+ 	 * TODO estimate more accurately
+ 	 */
+ 	fpinfo->startup_cost = fpinfo->fdw_startup_cost +
+ 						   fpinfo->local_conds_cost.startup;
+ 	fpinfo->total_cost = fpinfo->startup_cost +
+ 						 (fpinfo->fdw_tuple_cost +
+ 						  fpinfo->local_conds_cost.per_tuple +
+ 						  cpu_tuple_cost) * fpinfo->rows;
+ 
+ 	/* serverid and userid are respectively identical */
+ 	fpinfo->server = fpinfo_o->server;
+ 	fpinfo->umid = fpinfo_o->umid;
+ 
+ 	fpinfo->outerrel = outerrel;
+ 	fpinfo->innerrel = innerrel;
+ 	fpinfo->jointype = jointype;
+ 
+ 	/* This join can be pushed down safely */
+ 	fpinfo->pushdown_safe = true;
+ 
+ 	/* joinclauses and otherclauses will be set later */
+ }
+ 
+ /*
+  * Get a copy of unsorted, unparameterized path
+  */
+ static Path *
+ get_unsorted_unparameterized_path(List *paths)
+ {
+ 	ListCell   *l;
+ 
+ 	foreach(l, paths)
+ 	{
+ 		Path	   *path = (Path *) lfirst(l);
+ 
+ 		if (path->pathkeys == NIL && path->param_info == NULL)
+ 		{
+ 			switch (path->pathtype)
+ 			{
+ 				case T_MergeJoin:
+ 					{
+ 						MergePath  *retval = makeNode(MergePath);
+ 						*retval = *((MergePath *) path);
+ 						return (Path *) retval;
+ 					}
+ 				case T_HashJoin:
+ 					{
+ 						HashPath   *retval = makeNode(HashPath);
+ 						*retval = *((HashPath *) path);
+ 						return (Path *) retval;
+ 					}
+ 				case T_NestLoop:
+ 					{
+ 						NestPath   *retval = makeNode(NestPath);
+ 						*retval = *((NestPath *) path);
+ 						return (Path *) retval;
+ 					}
+ 				default:
+ 					elog(ERROR, "unrecognized node type: %d",
+ 						 (int) path->pathtype);
+ 					return NULL;
+ 			}
+ 		}
+ 	}
+ 	return NULL;
+ }
+ 
+ /*
+  * postgresGetForeignJoinPaths
+  *		Add possible ForeignPath to joinrel.
+  *
+  * Joins satisfy conditions below can be pushed down to the remote PostgreSQL
+  * server.
+  *
+  * 1) Join type is INNER or OUTER (one of LEFT/RIGHT/FULL)
+  * 2) Both outer and inner portions are safe to push-down
+  * 3) All foreign tables in the join belong to the same foreign server
+  * 4) All join conditions are safe to push down
+  * 5) No relation has local filter (this can be relaxed for INNER JOIN with
+  * no volatile function/operator, but as of now we want safer way)
+  */
+ static void
+ postgresGetForeignJoinPaths(PlannerInfo *root,
+ 							RelOptInfo *joinrel,
+ 							RelOptInfo *outerrel,
+ 							RelOptInfo *innerrel,
+ 							JoinType jointype,
+ 							JoinPathExtraData *extra)
+ {
+ 	PgFdwRelationInfo *fpinfo;
+ 	PgFdwRelationInfo *fpinfo_o;
+ 	PgFdwRelationInfo *fpinfo_i;
+ 	ForeignPath	   *joinpath;
+ 	double			rows;
+ 	Cost			startup_cost;
+ 	Cost			total_cost;
+ 	Path		   *subpath;
+ 
+ 	ListCell	   *lc;
+ 	List		   *joinclauses;
+ 	List		   *otherclauses;
+ 
+ 	/*
+ 	 * Skip if this join combination has been considered already.
+ 	 */
+ 	if (joinrel->fdw_private)
+ 	{
+ 		ereport(DEBUG3, (errmsg("combination already considered")));
+ 		return;
+ 	}
+ 
+ 	/*
+ 	 * Create unfinished PgFdwRelationInfo entry which is used to indicate that
+ 	 * the join relaiton is already considered but the join can't be pushed
+ 	 * down.  Once we know that this join can be pushed down, we fill the entry
+ 	 * and make it valid by calling merge_fpinfo.
+ 	 *
+ 	 * This unfinished entry prevents redandunt checks for a join combination
+ 	 * which is already known as unsafe to push down.
+ 	 */
+ 	fpinfo = (PgFdwRelationInfo *) palloc0(sizeof(PgFdwRelationInfo));
+ 	fpinfo->pushdown_safe = false;
+ 	joinrel->fdw_private = fpinfo;
+ 
+ 	/*
+ 	 * We support all outer joins in addition to inner join.  CROSS JOIN is
+ 	 * an INNER JOIN with no conditions internally, so will be checked later.
+ 	 */
+ 	if (jointype != JOIN_INNER && jointype != JOIN_LEFT &&
+ 		jointype != JOIN_RIGHT && jointype != JOIN_FULL)
+ 	{
+ 		ereport(DEBUG3, (errmsg("unsupported join type (SEMI, ANTI)")));
+ 		return;
+ 	}
+ 
+ 	/*
+ 	 * Having valid PgFdwRelationInfo marked as "safe to push down" in
+ 	 * RelOptInfo#fdw_private indicates that scanning against the relation can
+ 	 * be pushed down.  If either of them doesn't have PgFdwRelationInfo or it
+ 	 * is not marked as safe, give up to push down this join relation.
+ 	 */
+ 	fpinfo_o = (PgFdwRelationInfo *) outerrel->fdw_private;
+ 	if (!fpinfo_o || !fpinfo_o->pushdown_safe)
+ 	{
+ 		ereport(DEBUG3, (errmsg("outer is not safe to push-down")));
+ 		return;
+ 	}
+ 	fpinfo_i = (PgFdwRelationInfo *) innerrel->fdw_private;
+ 	if (!fpinfo_i || !fpinfo_i->pushdown_safe)
+ 	{
+ 		ereport(DEBUG3, (errmsg("inner is not safe to push-down")));
+ 		return;
+ 	}
+ 
+ 	/*
+ 	 * All relations in the join must belong to same server.  Having a valid
+ 	 * fdw_private means that all relations in the relations belong to the
+ 	 * server the fdw_private has, so what we should do is just compare
+ 	 * serverid of outer/inner relations.
+ 	 */
+ 	if (fpinfo_o->server->serverid != fpinfo_i->server->serverid)
+ 	{
+ 		ereport(DEBUG3, (errmsg("server unmatch")));
+ 		return;
+ 	}
+ 
+ 	/*
+ 	 * No source relation can have local conditions.  This can be relaxed
+ 	 * if the join is an inner join and local conditions don't contain
+ 	 * volatile function/operator, but as of now we leave it as future
+ 	 * enhancement.
+ 	 */
+ 	if (fpinfo_o->local_conds != NULL || fpinfo_i->local_conds != NULL)
+ 	{
+ 		ereport(DEBUG3, (errmsg("join with local filter")));
+ 		return;
+ 	}
+ 
+ 	/*
+ 	 * Separate restrictlist into two lists, join conditions and remote filters.
+ 	 */
+ 	joinclauses = extra->restrictlist;
+ 	if (IS_OUTER_JOIN(jointype))
+ 	{
+ 		extract_actual_join_clauses(joinclauses, &joinclauses, &otherclauses);
+ 	}
+ 	else
+ 	{
+ 		joinclauses = extract_actual_clauses(joinclauses, false);
+ 		otherclauses = NIL;
+ 	}
+ 
+ 	/*
+ 	 * Note that CROSS JOIN (cartesian product) is transformed to JOIN_INNER
+ 	 * with empty joinclauses.  Pushing down CROSS JOIN usually produces more
+ 	 * result than retrieving each tables separately, so we don't push down
+ 	 * such joins.
+ 	 */
+ 	if (jointype == JOIN_INNER && joinclauses == NIL)
+ 	{
+ 		ereport(DEBUG3, (errmsg("unsupported join type (CROSS)")));
+ 		return;
+ 	}
+ 
+ 	/*
+ 	 * Join condition must be safe to push down.
+ 	 */
+ 	foreach(lc, joinclauses)
+ 	{
+ 		Expr *expr = (Expr *) lfirst(lc);
+ 
+ 		if (!is_foreign_expr(root, joinrel, expr))
+ 		{
+ 			ereport(DEBUG3, (errmsg("join quals contains unsafe conditions")));
+ 			return;
+ 		}
+ 	}
+ 
+ 	/*
+ 	 * Other condition for the join must be safe to push down.
+ 	 */
+ 	foreach(lc, otherclauses)
+ 	{
+ 		Expr *expr = (Expr *) lfirst(lc);
+ 
+ 		if (!is_foreign_expr(root, joinrel, expr))
+ 		{
+ 			ereport(DEBUG3, (errmsg("filter contains unsafe conditions")));
+ 			return;
+ 		}
+ 	}
+ 
+ 	/* Here we know that this join can be pushed-down to remote side. */
+ 
+ 	/* Construct fpinfo for the join relation */
+ 	merge_fpinfo(outerrel, innerrel, fpinfo, jointype, joinrel->rows,
+ 				 joinrel->width); 
+ 	fpinfo->joinclauses = joinclauses;
+ 	fpinfo->otherclauses = otherclauses;
+ 
+ 	/* TODO determine more accurate cost and rows of the join. */
+ 	rows = joinrel->rows;
+ 	startup_cost = fpinfo->startup_cost;
+ 	total_cost = fpinfo->total_cost;
+ 
+ 	/* Get an alternative path for this foreign join */
+ 	subpath = get_unsorted_unparameterized_path(joinrel->pathlist);
+ 	if (subpath == NULL)
+ 		elog(ERROR, "could not get any alternative path for a foreign join");
+ 
+ 	/*
+ 	 * Create a new join path and add it to the joinrel which represents a join
+ 	 * between foreign tables.
+ 	 */
+ 	joinpath = create_foreignscan_path(root,
+ 									   joinrel,
+ 									   rows,
+ 									   startup_cost,
+ 									   total_cost,
+ 									   NIL,		/* no pathkeys */
+ 									   NULL,	/* no required_outer */
+ 									   subpath,
+ 									   NIL);	/* no fdw_private */
+ 
+ 	/* Add generated path into joinrel by add_path(). */
+ 	add_path(joinrel, (Path *) joinpath);
+ 	elog(DEBUG3, "join path added for (%s) join (%s)",
+ 		 bms_to_str(outerrel->relids), bms_to_str(innerrel->relids));
+ 
+ 	/* TODO consider parameterized paths */
+ }
+ 
+ /*
   * Create a tuple from the specified row of the PGresult.
   *
   * rel is the local representation of the foreign table, attinmeta is
***************
*** 2929,2941 **** postgresImportForeignSchema(ImportForeignSchemaStmt *stmt, Oid serverOid)
  static HeapTuple
  make_tuple_from_result_row(PGresult *res,
  						   int row,
! 						   Relation rel,
  						   AttInMetadata *attinmeta,
  						   List *retrieved_attrs,
  						   MemoryContext temp_context)
  {
  	HeapTuple	tuple;
- 	TupleDesc	tupdesc = RelationGetDescr(rel);
  	Datum	   *values;
  	bool	   *nulls;
  	ItemPointer ctid = NULL;
--- 3313,3326 ----
  static HeapTuple
  make_tuple_from_result_row(PGresult *res,
  						   int row,
! 						   const char *relname,
! 						   const char *query,
! 						   TupleDesc tupdesc,
  						   AttInMetadata *attinmeta,
  						   List *retrieved_attrs,
  						   MemoryContext temp_context)
  {
  	HeapTuple	tuple;
  	Datum	   *values;
  	bool	   *nulls;
  	ItemPointer ctid = NULL;
***************
*** 2962,2968 **** make_tuple_from_result_row(PGresult *res,
  	/*
  	 * Set up and install callback to report where conversion error occurs.
  	 */
! 	errpos.rel = rel;
  	errpos.cur_attno = 0;
  	errcallback.callback = conversion_error_callback;
  	errcallback.arg = (void *) &errpos;
--- 3347,3355 ----
  	/*
  	 * Set up and install callback to report where conversion error occurs.
  	 */
! 	errpos.relname = relname;
! 	errpos.query = query;
! 	errpos.tupdesc = tupdesc;
  	errpos.cur_attno = 0;
  	errcallback.callback = conversion_error_callback;
  	errcallback.arg = (void *) &errpos;
***************
*** 3052,3064 **** make_tuple_from_result_row(PGresult *res,
  static void
  conversion_error_callback(void *arg)
  {
  	ConversionLocation *errpos = (ConversionLocation *) arg;
! 	TupleDesc	tupdesc = RelationGetDescr(errpos->rel);
  
  	if (errpos->cur_attno > 0 && errpos->cur_attno <= tupdesc->natts)
! 		errcontext("column \"%s\" of foreign table \"%s\"",
! 				   NameStr(tupdesc->attrs[errpos->cur_attno - 1]->attname),
! 				   RelationGetRelationName(errpos->rel));
  }
  
  /*
--- 3439,3479 ----
  static void
  conversion_error_callback(void *arg)
  {
+ 	const char *attname;
+ 	const char *relname;
  	ConversionLocation *errpos = (ConversionLocation *) arg;
! 	TupleDesc	tupdesc = errpos->tupdesc;
! 	StringInfoData buf;
! 
! 	if (errpos->relname)
! 	{
! 		/* error occurred in a scan against a foreign table */ 
! 		initStringInfo(&buf);
! 		if (errpos->cur_attno > 0)
! 			appendStringInfo(&buf, "column \"%s\"",
! 					 NameStr(tupdesc->attrs[errpos->cur_attno - 1]->attname));
! 		else if (errpos->cur_attno == SelfItemPointerAttributeNumber)
! 			appendStringInfoString(&buf, "column \"ctid\"");
! 		attname = buf.data;
! 
! 		initStringInfo(&buf);
! 		appendStringInfo(&buf, "foreign table \"%s\"", errpos->relname);
! 		relname = buf.data;
! 	}
! 	else
! 	{
! 		/* error occurred in a scan against a foreign join */ 
! 		initStringInfo(&buf);
! 		appendStringInfo(&buf, "column %d", errpos->cur_attno - 1);
! 		attname = buf.data;
! 
! 		initStringInfo(&buf);
! 		appendStringInfo(&buf, "foreign join \"%s\"", errpos->query);
! 		relname = buf.data;
! 	}
  
  	if (errpos->cur_attno > 0 && errpos->cur_attno <= tupdesc->natts)
! 		errcontext("%s of %s", attname, relname);
  }
  
  /*
*** a/contrib/postgres_fdw/postgres_fdw.h
--- b/contrib/postgres_fdw/postgres_fdw.h
***************
*** 15,20 ****
--- 15,21 ----
  
  #include "foreign/foreign.h"
  #include "lib/stringinfo.h"
+ #include "nodes/plannodes.h"
  #include "nodes/relation.h"
  #include "utils/relcache.h"
  
***************
*** 26,31 ****
--- 27,38 ----
   */
  typedef struct PgFdwRelationInfo
  {
+ 	/*
+ 	 * True means that the relation can be pushed down.  Always true for
+ 	 * simple foreign scan.
+ 	 */
+ 	bool		pushdown_safe;
+ 
  	/* baserestrictinfo clauses, broken down into safe and unsafe subsets. */
  	List	   *remote_conds;
  	List	   *local_conds;
***************
*** 52,58 **** typedef struct PgFdwRelationInfo
  	/* Cached catalog information. */
  	ForeignTable *table;
  	ForeignServer *server;
! 	UserMapping *user;			/* only set in use_remote_estimate mode */
  } PgFdwRelationInfo;
  
  /* in postgres_fdw.c */
--- 59,72 ----
  	/* Cached catalog information. */
  	ForeignTable *table;
  	ForeignServer *server;
! 	Oid			umid;
! 
! 	/* Join information */
! 	RelOptInfo *outerrel;
! 	RelOptInfo *innerrel;
! 	JoinType	jointype;
! 	List	   *joinclauses;
! 	List	   *otherclauses;
  } PgFdwRelationInfo;
  
  /* in postgres_fdw.c */
***************
*** 88,100 **** extern void deparseSelectSql(StringInfo buf,
  				 PlannerInfo *root,
  				 RelOptInfo *baserel,
  				 Bitmapset *attrs_used,
! 				 List **retrieved_attrs);
! extern void appendWhereClause(StringInfo buf,
  				  PlannerInfo *root,
  				  RelOptInfo *baserel,
  				  List *exprs,
! 				  bool is_first,
  				  List **params);
  extern void deparseInsertSql(StringInfo buf, PlannerInfo *root,
  				 Index rtindex, Relation rel,
  				 List *targetAttrs, bool doNothing, List *returningList,
--- 102,134 ----
  				 PlannerInfo *root,
  				 RelOptInfo *baserel,
  				 Bitmapset *attrs_used,
! 				 List *remote_conds,
! 				 List *pathkeys,
! 				 List **params_list,
! 				 List **fdw_scan_tlist,
! 				 List **retrieved_attrs,
! 				 StringInfo relations,
! 				 bool alias);
! extern void appendConditions(StringInfo buf,
  				  PlannerInfo *root,
  				  RelOptInfo *baserel,
+ 				  List *outertlist,
+ 				  List *innertlist,
  				  List *exprs,
! 				  const char *prefix,
  				  List **params);
+ extern void deparseJoinSql(StringInfo sql,
+ 			   PlannerInfo *root,
+ 			   RelOptInfo *baserel,
+ 			   RelOptInfo *outerrel,
+ 			   RelOptInfo *innerrel,
+ 			   const char *sql_o,
+ 			   const char *sql_i,
+ 			   JoinType jointype,
+ 			   List *joinclauses,
+ 			   List *otherclauses,
+ 			   List **fdw_scan_tlist,
+ 			   List **retrieved_attrs);
  extern void deparseInsertSql(StringInfo buf, PlannerInfo *root,
  				 Index rtindex, Relation rel,
  				 List *targetAttrs, bool doNothing, List *returningList,
*** a/contrib/postgres_fdw/sql/postgres_fdw.sql
--- b/contrib/postgres_fdw/sql/postgres_fdw.sql
***************
*** 11,22 **** DO $d$
--- 11,27 ----
              OPTIONS (dbname '$$||current_database()||$$',
                       port '$$||current_setting('port')||$$'
              )$$;
+         EXECUTE $$CREATE SERVER loopback2 FOREIGN DATA WRAPPER postgres_fdw
+             OPTIONS (dbname '$$||current_database()||$$',
+                      port '$$||current_setting('port')||$$'
+             )$$;
      END;
  $d$;
  
  CREATE USER MAPPING FOR public SERVER testserver1
  	OPTIONS (user 'value', password 'value');
  CREATE USER MAPPING FOR CURRENT_USER SERVER loopback;
+ CREATE USER MAPPING FOR CURRENT_USER SERVER loopback2;
  
  -- ===================================================================
  -- create objects used through FDW loopback server
***************
*** 39,44 **** CREATE TABLE "S 1"."T 2" (
--- 44,61 ----
  	c2 text,
  	CONSTRAINT t2_pkey PRIMARY KEY (c1)
  );
+ CREATE TABLE "S 1"."T 3" (
+ 	c1 int NOT NULL,
+ 	c2 int NOT NULL,
+ 	c3 text,
+ 	CONSTRAINT t3_pkey PRIMARY KEY (c1)
+ );
+ CREATE TABLE "S 1"."T 4" (
+ 	c1 int NOT NULL,
+ 	c2 int NOT NULL,
+ 	c4 text,
+ 	CONSTRAINT t4_pkey PRIMARY KEY (c1)
+ );
  
  INSERT INTO "S 1"."T 1"
  	SELECT id,
***************
*** 54,62 **** INSERT INTO "S 1"."T 2"
--- 71,93 ----
  	SELECT id,
  	       'AAA' || to_char(id, 'FM000')
  	FROM generate_series(1, 100) id;
+ INSERT INTO "S 1"."T 3"
+ 	SELECT id,
+ 	       id + 1,
+ 	       'AAA' || to_char(id, 'FM000')
+ 	FROM generate_series(1, 100) id;
+ DELETE FROM "S 1"."T 3" WHERE c1 % 2 != 0;	-- delete for outer join tests
+ INSERT INTO "S 1"."T 4"
+ 	SELECT id,
+ 	       id + 1,
+ 	       'AAA' || to_char(id, 'FM000')
+ 	FROM generate_series(1, 100) id;
+ DELETE FROM "S 1"."T 4" WHERE c1 % 3 != 0;	-- delete for outer join tests
  
  ANALYZE "S 1"."T 1";
  ANALYZE "S 1"."T 2";
+ ANALYZE "S 1"."T 3";
+ ANALYZE "S 1"."T 4";
  
  -- ===================================================================
  -- create foreign tables
***************
*** 87,92 **** CREATE FOREIGN TABLE ft2 (
--- 118,146 ----
  ) SERVER loopback;
  ALTER FOREIGN TABLE ft2 DROP COLUMN cx;
  
+ CREATE FOREIGN TABLE ft4 (
+ 	c1 int NOT NULL,
+ 	c2 int NOT NULL,
+ 	c3 text
+ ) SERVER loopback OPTIONS (schema_name 'S 1', table_name 'T 3');
+ 
+ CREATE FOREIGN TABLE ft5 (
+ 	c1 int NOT NULL,
+ 	c2 int NOT NULL,
+ 	c3 text
+ ) SERVER loopback OPTIONS (schema_name 'S 1', table_name 'T 4');
+ 
+ CREATE FOREIGN TABLE ft6 (
+ 	c1 int NOT NULL,
+ 	c2 int NOT NULL,
+ 	c3 text
+ ) SERVER loopback2 OPTIONS (schema_name 'S 1', table_name 'T 4');
+ CREATE USER view_owner;
+ GRANT ALL ON ft5 TO view_owner;
+ CREATE VIEW v_ft5 AS SELECT * FROM ft5;
+ ALTER VIEW v_ft5 OWNER TO view_owner;
+ CREATE USER MAPPING FOR view_owner SERVER loopback;
+ 
  -- ===================================================================
  -- tests for validator
  -- ===================================================================
***************
*** 168,175 **** EXPLAIN (VERBOSE, COSTS false) SELECT * FROM ft1 t1 WHERE c1 = 102 FOR SHARE;
  SELECT * FROM ft1 t1 WHERE c1 = 102 FOR SHARE;
  -- aggregate
  SELECT COUNT(*) FROM ft1 t1;
- -- join two tables
- SELECT t1.c1 FROM ft1 t1 JOIN ft2 t2 ON (t1.c1 = t2.c1) ORDER BY t1.c3, t1.c1 OFFSET 100 LIMIT 10;
  -- subquery
  SELECT * FROM ft1 t1 WHERE t1.c3 IN (SELECT c3 FROM ft2 t2 WHERE c1 <= 10) ORDER BY c1;
  -- subquery+MAX
--- 222,227 ----
***************
*** 257,262 **** EXPLAIN (VERBOSE, COSTS false)
--- 309,394 ----
  SELECT count(c3) FROM ft1 t1 WHERE t1.c1 === t1.c2;
  
  -- ===================================================================
+ -- JOIN queries
+ -- ===================================================================
+ -- join two tables
+ EXPLAIN (COSTS false, VERBOSE)
+ SELECT t1.c1, t2.c1 FROM ft1 t1 JOIN ft2 t2 ON (t1.c1 = t2.c1) ORDER BY t1.c3, t1.c1 OFFSET 100 LIMIT 10;
+ SELECT t1.c1, t2.c1 FROM ft1 t1 JOIN ft2 t2 ON (t1.c1 = t2.c1) ORDER BY t1.c3, t1.c1 OFFSET 100 LIMIT 10;
+ -- join three tables
+ EXPLAIN (COSTS false, VERBOSE)
+ SELECT t1.c1, t2.c2, t3.c3 FROM ft1 t1 JOIN ft2 t2 ON (t1.c1 = t2.c1) JOIN ft4 t3 ON (t3.c1 = t1.c1) ORDER BY t1.c3, t1.c1 OFFSET 10 LIMIT 10;
+ SELECT t1.c1, t2.c2, t3.c3 FROM ft1 t1 JOIN ft2 t2 ON (t1.c1 = t2.c1) JOIN ft4 t3 ON (t3.c1 = t1.c1) ORDER BY t1.c3, t1.c1 OFFSET 10 LIMIT 10;
+ -- left outer join
+ EXPLAIN (COSTS false, VERBOSE)
+ SELECT t1.c1, t2.c1 FROM ft4 t1 LEFT JOIN ft5 t2 ON (t1.c1 = t2.c1) ORDER BY t1.c1, t2.c1 OFFSET 10 LIMIT 10;
+ SELECT t1.c1, t2.c1 FROM ft4 t1 LEFT JOIN ft5 t2 ON (t1.c1 = t2.c1) ORDER BY t1.c1, t2.c1 OFFSET 10 LIMIT 10;
+ -- right outer join
+ EXPLAIN (COSTS false, VERBOSE)
+ SELECT t1.c1, t2.c1 FROM ft5 t1 RIGHT JOIN ft4 t2 ON (t1.c1 = t2.c1) ORDER BY t2.c1, t1.c1 OFFSET 10 LIMIT 10;
+ SELECT t1.c1, t2.c1 FROM ft5 t1 RIGHT JOIN ft4 t2 ON (t1.c1 = t2.c1) ORDER BY t2.c1, t1.c1 OFFSET 10 LIMIT 10;
+ -- full outer join
+ EXPLAIN (COSTS false, VERBOSE)
+ SELECT t1.c1, t2.c1 FROM ft4 t1 FULL JOIN ft5 t2 ON (t1.c1 = t2.c1) ORDER BY t1.c1, t2.c1 OFFSET 45 LIMIT 10;
+ SELECT t1.c1, t2.c1 FROM ft4 t1 FULL JOIN ft5 t2 ON (t1.c1 = t2.c1) ORDER BY t1.c1, t2.c1 OFFSET 45 LIMIT 10;
+ -- full outer join + WHERE clause, only matched rows
+ EXPLAIN (COSTS false, VERBOSE)
+ SELECT t1.c1, t2.c1 FROM ft4 t1 FULL JOIN ft5 t2 ON (t1.c1 = t2.c1) WHERE (t1.c1 = t2.c1 OR t1.c1 IS NULL) ORDER BY t1.c1, t2.c1 OFFSET 10 LIMIT 10;
+ SELECT t1.c1, t2.c1 FROM ft4 t1 FULL JOIN ft5 t2 ON (t1.c1 = t2.c1) WHERE (t1.c1 = t2.c1 OR t1.c1 IS NULL) ORDER BY t1.c1, t2.c1 OFFSET 10 LIMIT 10;
+ -- join at WHERE clause 
+ EXPLAIN (COSTS false, VERBOSE)
+ SELECT t1.c1, t2.c1 FROM ft1 t1 JOIN ft2 t2 ON true WHERE (t1.c1 = t2.c1) ORDER BY t1.c3, t1.c1 OFFSET 100 LIMIT 10;
+ SELECT t1.c1, t2.c1 FROM ft1 t1 JOIN ft2 t2 ON true WHERE (t1.c1 = t2.c1) ORDER BY t1.c3, t1.c1 OFFSET 100 LIMIT 10;
+ -- join in CTE
+ EXPLAIN (COSTS false, VERBOSE)
+ WITH t (c1_1, c1_3, c2_1) AS (SELECT t1.c1, t1.c3, t2.c1 FROM ft1 t1 JOIN ft2 t2 ON (t1.c1 = t2.c1)) SELECT c1_1, c2_1 FROM t ORDER BY c1_3, c1_1 OFFSET 100 LIMIT 10;
+ WITH t (c1_1, c1_3, c2_1) AS (SELECT t1.c1, t1.c3, t2.c1 FROM ft1 t1 JOIN ft2 t2 ON (t1.c1 = t2.c1)) SELECT c1_1, c2_1 FROM t ORDER BY c1_3, c1_1 OFFSET 100 LIMIT 10;
+ -- ctid with whole-row reference
+ EXPLAIN (COSTS false, VERBOSE)
+ SELECT t1.ctid, t1, t2, t1.c1 FROM ft1 t1 JOIN ft2 t2 ON (t1.c1 = t2.c1) ORDER BY t1.c3, t1.c1 OFFSET 100 LIMIT 10;
+ SELECT t1.ctid, t1, t2, t1.c1 FROM ft1 t1 JOIN ft2 t2 ON (t1.c1 = t2.c1) ORDER BY t1.c3, t1.c1 OFFSET 100 LIMIT 10;
+ -- partially unsafe to push down, not pushed down
+ EXPLAIN (COSTS false, VERBOSE)
+ SELECT t1.c1 FROM ft1 t1 JOIN ft2 t2 ON t2.c1 = t2.c1 JOIN ft4 t3 ON t2.c1 = t3.c1 ORDER BY t1.c1 OFFSET 10 LIMIT 10;
+ SELECT t1.c1 FROM ft1 t1 JOIN ft2 t2 ON t2.c1 = t2.c1 JOIN ft4 t3 ON t2.c1 = t3.c1 ORDER BY t1.c1 OFFSET 10 LIMIT 10;
+ -- SEMI JOIN, not pushed down
+ EXPLAIN (COSTS false, VERBOSE)
+ SELECT t1.c1 FROM ft1 t1 WHERE EXISTS (SELECT 1 FROM ft2 t2 WHERE t1.c1 = t2.c1) ORDER BY t1.c1 OFFSET 100 LIMIT 10;
+ SELECT t1.c1 FROM ft1 t1 WHERE EXISTS (SELECT 1 FROM ft2 t2 WHERE t1.c1 = t2.c1) ORDER BY t1.c1 OFFSET 100 LIMIT 10;
+ -- ANTI JOIN, not pushed down
+ EXPLAIN (COSTS false, VERBOSE)
+ SELECT t1.c1 FROM ft1 t1 WHERE NOT EXISTS (SELECT 1 FROM ft2 t2 WHERE t1.c1 = t2.c2) ORDER BY t1.c1 OFFSET 100 LIMIT 10;
+ SELECT t1.c1 FROM ft1 t1 WHERE NOT EXISTS (SELECT 1 FROM ft2 t2 WHERE t1.c1 = t2.c2) ORDER BY t1.c1 OFFSET 100 LIMIT 10;
+ -- CROSS JOIN, not pushed down
+ EXPLAIN (COSTS false, VERBOSE)
+ SELECT t1.c1, t2.c1 FROM ft1 t1 CROSS JOIN ft2 t2 ORDER BY t1.c1, t2.c1 OFFSET 100 LIMIT 10;
+ SELECT t1.c1, t2.c1 FROM ft1 t1 CROSS JOIN ft2 t2 ORDER BY t1.c1, t2.c1 OFFSET 100 LIMIT 10;
+ -- different server
+ EXPLAIN (COSTS false, VERBOSE)
+ SELECT t1.c1, t2.c1 FROM ft5 t1 JOIN ft6 t2 ON (t1.c1 = t2.c1) ORDER BY t1.c1, t2.c1 OFFSET 100 LIMIT 10;
+ SELECT t1.c1, t2.c1 FROM ft5 t1 JOIN ft6 t2 ON (t1.c1 = t2.c1) ORDER BY t1.c1, t2.c1 OFFSET 100 LIMIT 10;
+ -- different effective user for permission check
+ EXPLAIN (COSTS false, VERBOSE)
+ SELECT t1.c1, t2.c1 FROM ft5 t1 JOIN v_ft5 t2 ON (t1.c1 = t2.c1) ORDER BY t1.c1, t2.c1 OFFSET 100 LIMIT 10;
+ SELECT t1.c1, t2.c1 FROM ft5 t1 JOIN v_ft5 t2 ON (t1.c1 = t2.c1) ORDER BY t1.c1, t2.c1 OFFSET 100 LIMIT 10;
+ -- unsafe join conditions
+ EXPLAIN (COSTS false, VERBOSE)
+ SELECT t1.c1, t2.c1 FROM ft1 t1 JOIN ft2 t2 ON (t1.c8 = t2.c8) ORDER BY t1.c3, t1.c1 OFFSET 100 LIMIT 10;
+ SELECT t1.c1, t2.c1 FROM ft1 t1 JOIN ft2 t2 ON (t1.c8 = t2.c8) ORDER BY t1.c3, t1.c1 OFFSET 100 LIMIT 10;
+ -- local filter (unsafe conditions on one side)
+ EXPLAIN (COSTS false, VERBOSE)
+ SELECT t1.c1, t2.c1 FROM ft1 t1 JOIN ft2 t2 ON (t1.c1 = t2.c1) WHERE t1.c8 = 'foo' ORDER BY t1.c3, t1.c1 OFFSET 100 LIMIT 10;
+ SELECT t1.c1, t2.c1 FROM ft1 t1 JOIN ft2 t2 ON (t1.c1 = t2.c1) WHERE t1.c8 = 'foo' ORDER BY t1.c3, t1.c1 OFFSET 100 LIMIT 10;
+ -- Aggregate after UNION, for testing setrefs
+ EXPLAIN (COSTS false, VERBOSE)
+ SELECT t1c1, avg(t1c1 + t2c1) FROM (SELECT t1.c1, t2.c1 FROM ft1 t1 JOIN ft2 t2 ON (t1.c1 = t2.c1) UNION SELECT t1.c1, t2.c1 FROM ft1 t1 JOIN ft2 t2 ON (t1.c1 = t2.c1)) AS t (t1c1, t2c1) GROUP BY t1c1 ORDER BY t1c1 OFFSET 100 LIMIT 10;
+ SELECT t1c1, avg(t1c1 + t2c1) FROM (SELECT t1.c1, t2.c1 FROM ft1 t1 JOIN ft2 t2 ON (t1.c1 = t2.c1) UNION SELECT t1.c1, t2.c1 FROM ft1 t1 JOIN ft2 t2 ON (t1.c1 = t2.c1)) AS t (t1c1, t2c1) GROUP BY t1c1 ORDER BY t1c1 OFFSET 100 LIMIT 10;
+ -- join two foreign tables and two local tables
+ EXPLAIN (COSTS false, VERBOSE)
+ SELECT t1.c1, t2.c1 FROM ft1 t1 LEFT JOIN ft2 t2 ON t1.c1 = t2.c1 JOIN "S 1"."T 1" t3 ON t1.c1 = t3."C 1" JOIN "S 1"."T 2" t4 ON t1.c1 = t4.c1 ORDER BY t1.c1 OFFSET 10 LIMIT 10;
+ SELECT t1.c1, t2.c1 FROM ft1 t1 LEFT JOIN ft2 t2 ON t1.c1 = t2.c1 JOIN "S 1"."T 1" t3 ON t1.c1 = t3."C 1" JOIN "S 1"."T 2" t4 ON t1.c1 = t4.c1 ORDER BY t1.c1 OFFSET 10 LIMIT 10;
+ 
+ -- ===================================================================
  -- parameterized queries
  -- ===================================================================
  -- simple join
***************
*** 880,882 **** DROP TYPE "Colors" CASCADE;
--- 1012,1018 ----
  IMPORT FOREIGN SCHEMA import_source LIMIT TO (t5)
    FROM SERVER loopback INTO import_dest5;  -- ERROR
  ROLLBACK;
+ 
+ -- Cleanup
+ DROP OWNED BY view_owner;
+ DROP USER view_owner;
